
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <conio.h>

#include "bass.h"

HSTREAM hMP3;
DWORD dwStreamLen;
DWORD dwStreamCurrentPos;
float fSeconds;
float fSecondsTotal;

int main(int argc, char **argv) {
	
	if (argc != 2) {
		
		printf("\nUsage:\n%s file\n\nFile can be one mp3 or wav.\n", argv[0]);
		return 1;
		
	}
	
	if (BASS_Init(-1, 22050, 0, 0) == false) {
		
		printf("Error: Can\'t initialize BASS\n");
		return 2;
		
	}
	
	if (BASS_Start() == false) {
		
		printf("Error: Can\'t start digital output\n");
		BASS_Free();
		return 3;
		
	}
	
	hMP3 = BASS_StreamCreateFile(false, argv[1], 0, 0, BASS_MP3_SETPOS);
	
	if (hMP3 == 0) {
		
		printf("Error: Can\'t load \"%s\"\n", argv[1]);
		BASS_Free();
		return 4;
		
	}
	
	dwStreamLen = BASS_StreamGetLength(hMP3);
	fSecondsTotal = BASS_ChannelBytes2Seconds(hMP3, dwStreamLen);
	BASS_StreamPlay(hMP3, false, 0);
	
	printf("Playback of \"%s\":\n", argv[1]);
	
	do {
		
		dwStreamCurrentPos = BASS_ChannelGetPosition(hMP3);
		fSeconds = BASS_ChannelBytes2Seconds(hMP3, dwStreamCurrentPos);
		
		printf("\rSeconds: %3.0f/%3.0f ", fSeconds, fSecondsTotal);
		
		Sleep(10);
		
	} while (dwStreamCurrentPos != dwStreamLen && !kbhit());
	
	BASS_Free();
	
	return 0;
	
}